/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.client.environment;

import jakarta.ws.rs.client.Client;
import jakarta.ws.rs.client.ClientBuilder;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.glassfish.jersey.client.ClientConfig;
import org.glassfish.jersey.client.ClientProperties;



/**
 * Die Verbindungszeit und Antwortzeit wird für alle Clients gesetzt, bevor ein
 * Timeout erfolgt.
 */
public final class JerseyClientFactory {

  private final static Logger log = LogManager.getLogger(JerseyClientFactory.class);
  private static final Client CLIENT;

  private JerseyClientFactory() {}

  static {
    ClientConfig config = new ClientConfig();
    config.property(ClientProperties.CONNECT_TIMEOUT, 3000).property(ClientProperties.READ_TIMEOUT, 12000);
    CLIENT = ClientBuilder.newClient(config);
  }

  public static Client getClient() {
    return CLIENT;

  }



  /**
   * Muss vor Programmende aufgerufen werden.
   */
  public static void shutdown() {
    log.trace(">>> JerseyClientFactory.shutdown() called by thread: {}", Thread.currentThread().getName());
    log.trace("Shutdown call stack trace:", new Exception("TRACE"));
    CLIENT.close();
    log.trace("JerseyClientFactory shutdown completed.");
  }
}
